"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = getIgnoreRegex;

var _getConfigurationFromPackage = require("./getConfigurationFromPackage");

var _getConfigurationFromPackage2 = _interopRequireDefault(_getConfigurationFromPackage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getIgnoreRegex() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$includeDevScopes = _ref.includeDevScopes,
      includeDevScopes = _ref$includeDevScopes === undefined ? [] : _ref$includeDevScopes,
      module = _ref.module,
      rootDirectory = _ref.rootDirectory;

  if (
  // FIXME: Replace with the proper utility once the utility module is out
  // there.
  process.env.NODE_ENV !== "production") {
    if (!includeDevScopes.length) {
      var configurationFromPackage = (0, _getConfigurationFromPackage2.default)({
        module,
        rootDirectory
      });

      if (configurationFromPackage.includeDevScopes) {
        includeDevScopes.push.apply(includeDevScopes, (0, _toConsumableArray3.default)(configurationFromPackage.includeDevScopes));
      }
    }

    return new RegExp(`node_modules[\\\\/](?!@(${ ["novivia"].concat((0, _toConsumableArray3.default)(includeDevScopes)).join("|") })[\\\\/])`);
  }

  return (/node_modules/
  );
} /**
   * Copyright 2013-present, Novivia, Inc.
   * All rights reserved.
   */

module.exports = exports["default"];