"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

exports.default = requireHook;

var _backend = require("../config/backend");

var _backend2 = _interopRequireDefault(_backend);

var _getConfigurationFromPackage = require("./getConfigurationFromPackage");

var _getConfigurationFromPackage2 = _interopRequireDefault(_getConfigurationFromPackage);

var _getIgnoreRegex = require("./getIgnoreRegex");

var _getIgnoreRegex2 = _interopRequireDefault(_getIgnoreRegex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A module providing a utility to bootstrap and configure in-memory require
 * hooks.
 */

function requireHook() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$babelOptions = _ref.babelOptions,
      babelOptions = _ref$babelOptions === undefined ? {} : _ref$babelOptions,
      module = _ref.module,
      rootDirectory = _ref.rootDirectory,
      _ref$useJSON = _ref.useJSON5,
      useJSON5 = _ref$useJSON === undefined ? true : _ref$useJSON,
      _ref$usePolyfill = _ref.usePolyfill,
      usePolyfill = _ref$usePolyfill === undefined ? true : _ref$usePolyfill;

  var configurationFromPackage = (0, _getConfigurationFromPackage2.default)({
    module,
    rootDirectory
  });

  var babelConfiguration = (0, _backend2.default)({
    convertFlowToTypeCheck: true,
    eliminateNonBuildingCode: false
  });

  var finalBabelConfiguration = (0, _extends3.default)({
    // Ignore nothing by default. "node_modules" will be added with different
    // conditions below.
    ignore: [],

    // Compile in the program directory by default.
    sourceRoot: process.cwd()

  }, babelConfiguration, configurationFromPackage.babelOptions || {}, babelOptions);

  finalBabelConfiguration.ignore = finalBabelConfiguration.ignore || [];
  finalBabelConfiguration.ignore.push((0, _getIgnoreRegex2.default)({
    includeDevScopes: configurationFromPackage.includeDevScopes,
    module,
    rootDirectory
  }));

  if (useJSON5) {
    require("json5/lib/require");
  }

  /* istanbul ignore if */
  if (usePolyfill) {
    require("babel-polyfill");
  }

  require("babel-register")(finalBabelConfiguration);
} /**
   * Copyright 2013-present, Novivia, Inc.
   * All rights reserved.
   */

module.exports = exports["default"];